from NSCP import Settings, Registry, Core, log, log_err, status

from ConfigParser import SafeConfigParser
import ConfigParser
import os
import sys
import shutil
import codecs
import subprocess
import time

plugin_id = 0

def check_ini(arguments):
    notutf8 = False
    BOM =False
    notcp1251 =False
    c1=''
    c2=''
    c3 = ''
    parser = SafeConfigParser()
    try:
        parser.read('C:/runpos/local.ini')
        if parser.has_section('ENCODING'):
            c1 = 'checkEncoding:ok\n'
        else:
            c1 =  'checkEncoding:ok, but section is undefinedn\n'
    except ConfigParser.ParsingError:
        c1 =  'critical, encoding unknown\n'
        BOM = True

    cfgfile = codecs.open('C:/runpos/local.ini', 'r', encoding='cp1251')
    try:
        u = cfgfile.read()
        c2= 'encoding: cp1251\n'
    except UnicodeDecodeError:
        c2= 'encoding: not cp1251\n'
        notcp1251 = True

    cfgfile = codecs.open('C:/runpos/local.ini', 'r', encoding='utf-8')
    try:
        u = cfgfile.read()
        c3= 'encoding: utf-8\n'
    except UnicodeDecodeError:
        c3= 'encoding: not utf-8\n'
        notutf8 = True

    if BOM:
        return (status.CRITICAL, 'critical, encoding unknown c1={c1},c2={c2},c3={c3}'.format(c1=c1,c2=c2,c3=c3))
    else:
        if notcp1251:
            return (status.WARNING, 'encoding: not cp1251, c1={c1},c2={c2},c3={c3}'.format(c1=c1,c2=c2,c3=c3))
        else:
            if notutf8:
                return (status.WARNING, 'encoding: not utf-8, c1={c1},c2={c2},c3={c3}'.format(c1=c1,c2=c2,c3=c3))
            else:
                return (status.OK, 'checkEncoding:ok, and section ENCODING exist,c1={c1},c2={c2},c3={c3}'.format(c1=c1,c2=c2,c3=c3))

def check_world(arguments):
    return (status.OK, 'The world is fine!')
    #return (status.CRITICAL, 'My god its full of stars: %s'%world_status)

def update_config_runpos(arguments):
    if os.path.isfile('C:/runpos/config.ini'):
        shutil.copy2('C:/runpos/config.ini', 'C:/runpos/bak/config.ini')
    if os.path.isfile('./runpos/config.ini'):
        shutil.copy2('./runpos/config.ini', 'C:/runpos/config.ini')
    return (status.CRITICAL, 'Config updated')

def update_full(arguments):
    subprocess.call(["C:\\Python27\\python.exe", "C:\\Program files\\Nsclient++\\Scripts\\1.py"])
    try:
        os.makedirs('C:/runpos/bak/')
    except OSError:
        pass

    update_config_runpos(arguments)
    if os.path.isfile('C:/runpos/runpos.exe'):
        shutil.copy2('C:/runpos/runpos.exe', 'C:/runpos/bak/runpos.exe')
    if os.path.isfile('./runpos/runpos.exe'):
        shutil.copy2('./runpos/runpos.exe', 'C:/runpos/runpos.exe')

    time.sleep(10)
    subprocess.Popen('C:/runpos/localserver.exe')
    return (status.OK, 'RunPOS updated')


def get_help(arguments):
    if arguments:
        log("Wicked: we got some args")
    return (status.OK, 'Need help? Sorry, Im not help full my friend...')


def __main__(args):
    get_help(args)

def init(pid, plugin_alias, script_alias):
    global plugin_id
    plugin_id = pid

    conf = Settings.get(plugin_id)
    conf.register_path('/settings/cool script', "Sample script config",
                       "This is a sample script which demonstrates how to interact with NSClient++")
    conf.register_key('/settings/cool script', 'world', 'string', "A key",
                      "Never ever change this key: or the world will break", "safe")

    world_status = conf.get_string('/settings/cool script', 'world', 'true')
    if world_status != 'safe':
        log('My god: its full of stars: %s' % world_status)

    log('Adding a simple function/cmd line')
    reg = Registry.get(plugin_id)
    reg.simple_cmdline('help', get_help)

    reg.simple_function('check_world', check_world, 'Check if the world is safe')
    reg.simple_function('check_ini', check_ini, 'Break the world')
    reg.simple_function('update_config_runpos', update_config_runpos, 'Break the world')
    reg.simple_function('update_full', update_full, 'Break the world')
    
def shutdown():
    log('Unloading script...')
